; dac1_8bit_wizard_MT.a51   8-bit resolution
; NOTE that this program is incomplete

; rev path 3/16
	$NOSYMBOLS		; keeps listing short
	$INCLUDE (C:\SiLabs\MCU\INC\c8051f410.inc) 
	$INCLUDE (C:\SiLabs\MCU\INC\VECTORS320.INC)	; Tom's vectors definition file

	STACKBOT EQU 07Fh		; put stack at start of scratch indirectly-addressable block (80h and up)

	ORG 0h
	LJMP STARTUP

	ORG 080h
				
STARTUP: MOV SP, #STACKBOT

	acall USUAL_SETUP

  acall Init_Device ; let the wizard do the work for us
  setb p0.1				; make sure DAC pin is high

; here's 8-bit ramp
	  CLR A

EIGHT_BIT:        ______________ ; transfer current "ramp" value to DAC1 (high byte)
                  ______________ ; increment ramp value
                  ______________ ; waste a little time (use DELAYSHORT routine)
                  ______________ ; keep doing this, forever

DELAYSHORT: PUSH ACC
			MOV A, #10H
			DJNZ ACC, $
			POP ACC
			RET

USUAL_SETUP: 	ANL PCA0MD, #not(040h)	; disable WDT
      ret

;------------------------------------
;-  Generated Initialization File  --
;------------------------------------
; Initialization function for device,
; Call Init_Device from your main program
Init_Device:
    lcall DAC_Init
    lcall Port_IO_Init
    ret

; Peripheral specific initialization functions,
; Called from the Init_Device label
DAC_Init:
    mov  IDA1CN,    #0F2h
    ret

Port_IO_Init:
    ; P0.0  -  Unassigned,  Open-Drain, Digital
    ; P0.1  -  Skipped,     Open-Drain, Analog
    ; P0.2  -  Unassigned,  Open-Drain, Digital
    ; P0.3  -  Unassigned,  Open-Drain, Digital


    mov  P0MDIN,    #0FDh
    mov  P0SKIP,    #002h
    mov  XBR1,      #040h
    ret

end
